"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const crypto_1 = require("crypto");
const express_1 = __importDefault(require("express"));
const fs_1 = __importDefault(require("fs"));
const MODULE_NAME = 'EXPRESSAPP_ROUTEMANAGER';
class RouteManager {
    constructor(app, rootDir) {
        this._app = app;
        this._routePath = `${rootDir}/routes`;
    }
    init() {
        return __awaiter(this, void 0, void 0, function* () {
            const files = fs_1.default.readdirSync(this._routePath);
            const routeNames = files.filter((f) => {
                var _a, _b, _c;
                const fname = f.split('.');
                if (fname.length !== 3 || ((_a = fname[1]) === null || _a === void 0 ? void 0 : _a.toLowerCase()) !== 'rt' || !(((_b = fname[2]) === null || _b === void 0 ? void 0 : _b.toLowerCase()) === 'ts' || ((_c = fname[2]) === null || _c === void 0 ? void 0 : _c.toLowerCase()) === 'js')) {
                    return false;
                }
                return true;
            });
            this._app.log.info(`[${MODULE_NAME}]: Found ${routeNames.length} route(s)`);
            if (routeNames.length > 0) {
                const loadRoutePromises = [];
                for (let i = 0; i < routeNames.length; i += 1) {
                    loadRoutePromises.push((() => __awaiter(this, void 0, void 0, function* () {
                        var _a;
                        var _b, _c, _d;
                        const router = express_1.default.Router();
                        router.use((req, _res, next) => {
                            req.headers['trace-token'] = (0, crypto_1.randomUUID)();
                            this._app.log.debug(`Request established at '${req.path}'`, { traceToken: req.headers['trace-token'] });
                            next();
                        });
                        const routeFilePath = `${this._routePath}/${routeNames[i]}`;
                        const loadRouter = yield (_a = routeFilePath, Promise.resolve().then(() => __importStar(require(_a))));
                        this._app.log.info(`[${MODULE_NAME}]: Loading route file ${routeFilePath}`);
                        yield loadRouter.default(this._app, router);
                        const fname = (_b = routeNames[i]) === null || _b === void 0 ? void 0 : _b.split('.');
                        let routeName = '/';
                        if (fname && ((_c = fname[0]) === null || _c === void 0 ? void 0 : _c.toLowerCase()) !== 'index') {
                            routeName = `/${(_d = fname[0]) === null || _d === void 0 ? void 0 : _d.split('_').join('/')}`;
                        }
                        this._app.express.use(routeName, router);
                        this._app.log.info(`[${MODULE_NAME}]: route created for ${routeName}`);
                    }))());
                }
                yield Promise.all(loadRoutePromises);
            }
        });
    }
}
exports.default = RouteManager;
//# sourceMappingURL=RouteManager.js.map